package jp.ac.nagoya_cu.sda.paper;
import java.awt.Point;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import javax.media.j3d.Appearance;
import javax.media.j3d.Canvas3D;
import javax.media.j3d.ColoringAttributes;
import javax.media.j3d.LineAttributes;
import javax.media.j3d.Material;
import javax.media.j3d.PointAttributes;
import javax.media.j3d.PolygonAttributes;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransparencyAttributes;
import javax.vecmath.Color3f;
import javax.vecmath.Point3d;

import jp.ac.nagoya_cu.sda.paper.shape.LineShape;
import jp.ac.nagoya_cu.sda.paper.shape.OrigamiShape;
import jp.ac.nagoya_cu.sda.paper.shape.PointShape;

import com.sun.j3d.utils.picking.PickResult;

public class OriUtil {

	/**
	 * 3ԏ̎_̈ʒuԂ
	 * @return
	 */
	public static Point3d getCenterEyePosVW(Canvas3D canvas){
		Transform3D viewtrans = new Transform3D();
		Point3d pview = new Point3d();
		canvas.getCenterEyeInImagePlate(pview);
		canvas.getImagePlateToVworld(viewtrans);
		viewtrans.transform(pview);
		return pview;
	}

	/**
	 * ^ꂽ_Ǝ_̒Ԃ̓_擾
	 * @param p3d
	 * @return
	 */
	public static Point3d getShortPointVW(Canvas3D canvas,Point3d p3d) {
		Point3d newP3d = new Point3d(p3d);
		Point3d pview=getCenterEyePosVW(canvas);
		newP3d.sub(pview);
		newP3d.scale(1 / 2d);
		newP3d.add(pview);
		return newP3d;
	}
	
	/**
	 * }EXŃNbNꏊ̉zԓł̈ʒu߂
	 * @param p }EXW
	 * @return Point3d 3W
	 */
	public static Point3d getPointVW(Canvas3D canvas,Point p) {
		return getPointVW(canvas,p.x,p.y);
	}
	/**
	 * }EXŃNbNꏊ̉zԓł̈ʒu߂
	 * @return Point3d 3W
	 */
	public static Point3d getPointVW(Canvas3D canvas,int x,int y) {
		Transform3D viewtrans = new Transform3D();
		Point3d mouseP3d = new Point3d(); // }EẌʒuێ

		canvas.getPixelLocationInImagePlate(x, y, mouseP3d);
		canvas.getImagePlateToVworld(viewtrans);
		viewtrans.transform(mouseP3d);

		return mouseP3d;
	}

	/**
	 * NbNꏊԂBPointShapeALineShapeD悵ĕԂB
	 * @return
	 */
	public static Point3d getPickedLocation(Canvas3D canvas,Point p,PickResult[] res) {
		if (res != null) {
			//System.out.println(res.getObject().getClass().getSimpleName());
			for(int i=0;i<res.length;i++){
				//System.out.println(i+" "+res[i].getNode(PickResult.BRANCH_GROUP).getClass().getSimpleName());
				// PointShapeALineShapeDIɕԂ
				OrigamiShape shp=(OrigamiShape)res[i].getNode(PickResult.BRANCH_GROUP);
				if(shp instanceof PointShape){
					PointShape ps=(PointShape)shp;
					return ps.getPoint();
				}else if(shp instanceof LineShape){
					return res[i].getIntersection(0).getPointCoordinates();
				}
			}
			return res[0].getIntersection(0).getPointCoordinates();
		}

		return null;
	}
	/**
	 * NbNꏊԂBPointShapeALineShapeD悵ĕԂBresnull̏ꍇ͋ԏ̃}EXWԂB
	 * @return
	 */
	public static Point3d getPickedLocationVW(Canvas3D canvas,Point p,PickResult[] res) {
		if (res != null) {
			//System.out.println(res.getObject().getClass().getSimpleName());
			for(int i=0;i<res.length;i++){
				//System.out.println(i+" "+res[i].getNode(PickResult.BRANCH_GROUP).getClass().getSimpleName());
				// PointShapeALineShapeDIɕԂ
				if(res[i].getNode(PickResult.BRANCH_GROUP) instanceof PointShape
						|| res[i].getNode(PickResult.BRANCH_GROUP) instanceof LineShape){
					return res[i].getIntersection(0).getPointCoordinatesVW();
				}
			}
			return res[0].getIntersection(0).getPointCoordinatesVW();
		}

		return getPointVW(canvas,p);
	}
	/**
	 * NbNIuWFNgԂBPointShapeALineShapeD悵ĕԂ
	 * @return
	 */
	public static OrigamiShape getPickedOrigamiShape(PickResult[] res) {
		if (res != null) {
			double dist=res[0].getIntersection(0).getDistance();
			for(int i=0;i<res.length;i++){
				if(res[i].getIntersection(0).getDistance()-dist >1e-3){
					break;
				}
				// PointShapeALineShapeDIɕԂ
				if(res[i].getNode(PickResult.BRANCH_GROUP) instanceof PointShape
						|| res[i].getNode(PickResult.BRANCH_GROUP) instanceof LineShape){
					return (OrigamiShape)res[i].getNode(PickResult.BRANCH_GROUP);
				}
			}
			return (OrigamiShape)res[0].getNode(PickResult.BRANCH_GROUP);
		}

		return null;
	}
	public static List<OrigamiShape> getAllPickedOrigamiShapes(PickResult[] res,OrigamiShape shp) {
		List<OrigamiShape> listPointShape=new ArrayList<OrigamiShape>();
		List<OrigamiShape> listLineShape=new ArrayList<OrigamiShape>();
		List<OrigamiShape> listShape=new ArrayList<OrigamiShape>();
		if (res != null) {
			for(int i=0;i<res.length;i++){
				OrigamiShape shape=(OrigamiShape)(res[i].getNode(PickResult.BRANCH_GROUP));
				if(shape instanceof PointShape){
					listPointShape.add(shape);
				}
				else if(shape instanceof LineShape){
					listLineShape.add(shape);
				}else{
					listShape.add(shape);
				}
			}
			
			//shpƓ^Ԃ
			if(shp instanceof PointShape){
				return listPointShape;
			}else if(shp instanceof LineShape){
				return listLineShape;
			}else{
				return listShape;
			}
		}

		return listShape;
	}

	public static Appearance createLineAppearance(Color3f color, float width,int pattern) {
		Appearance ap = new Appearance();

		ColoringAttributes ca = new ColoringAttributes();
		ca.setShadeModel(ColoringAttributes.FASTEST);
		ca.setColor(color);
		ap.setColoringAttributes(ca);

		LineAttributes lattr = new LineAttributes();
		lattr.setLineWidth(width);
		lattr.setLineAntialiasingEnable(true);
		lattr.setLinePattern(pattern);
		ap.setLineAttributes(lattr);
		return ap;
	}
	
	public static Appearance createPointAppearance(Color3f color, float size) {
		Appearance ap = new Appearance();

		ColoringAttributes ca = new ColoringAttributes();
		ca.setShadeModel(ColoringAttributes.FASTEST);
		ca.setColor(color);
		ap.setColoringAttributes(ca);

		PointAttributes pa=new PointAttributes();
		pa.setPointAntialiasingEnable(true);
		pa.setPointSize(size);
		ap.setPointAttributes(pa);
		return ap;
	}
	public static Appearance createSelectedPlaneAppearance(Color3f color,boolean isRightside) {
		
		ColoringAttributes ca = new ColoringAttributes();
		ca.setShadeModel(ColoringAttributes.FASTEST);
		ca.setColor(color);
		
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(PolygonAttributes.POLYGON_FILL);
		pa.setBackFaceNormalFlip(true);
		pa.setPolygonOffset(-1);
		if(isRightside){
			pa.setCullFace(PolygonAttributes.CULL_BACK);
		}else{
			pa.setCullFace(PolygonAttributes.CULL_FRONT);
		}
		
		TransparencyAttributes ta=new TransparencyAttributes(TransparencyAttributes.NICEST,0.5f);

		Appearance ap = new Appearance();
		ap.setPolygonAttributes(pa);
		ap.setTransparencyAttributes(ta);
		ap.setColoringAttributes(ca);

		return ap;
	}


	private static VertexPoint createNewVertexPoint(double x,double y){
		double r=1;
		return new VertexPoint(x*r,y*r,0,x*r,y*r);
	}
	public static PaperSnapShot createSquarePaper(double width,double height){
		
		List<VertexPoint> vertices=new ArrayList<VertexPoint>();
		vertices.add (createNewVertexPoint(-width/2,-height/2));
		vertices.add (createNewVertexPoint(-width/2,+height/2));
		vertices.add (createNewVertexPoint(+width/2,+height/2));
		vertices.add (createNewVertexPoint(+width/2,-height/2));
		
		
		List<EdgeLine> edges=new ArrayList<EdgeLine>();
		edges.add(new EdgeLine(vertices.get(0),vertices.get(3)));
		edges.add(new EdgeLine(vertices.get(1),vertices.get(0)));
		edges.add(new EdgeLine(vertices.get(2),vertices.get(1)));
		edges.add(new EdgeLine(vertices.get(3),vertices.get(2)));

		List<FoldingLine> foldlines=new ArrayList<FoldingLine>();
		
		List<Line> lns=new LinkedList<Line>();
		lns.add(edges.get(0));
		lns.add(edges.get(1));
		lns.add(edges.get(2));
		lns.add(edges.get(3));
		PlaneGeometry pg=new PlaneGeometry(lns);
		
		List<PlaneGeometry> pgl=new ArrayList<PlaneGeometry>();
		pgl.add(pg);
		
		PaperSnapShot snap=new PaperSnapShot(vertices,edges,foldlines,pgl);
		
		return snap;
	}

}
