package jp.ac.nagoya_cu.sda.paper;
/**
 * ܂莆Ő܂ꂽ`Ɋւێ
 */

/**
 * @author yousuke
 *
 */

//import java.util.Enumeration;


import java.awt.Component;
import java.util.Arrays;
import java.util.Enumeration;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.Iterator;
import java.util.List;
import java.util.Stack;

import javax.media.j3d.*;
import javax.vecmath.Color3f;
import javax.vecmath.Point2d;
import javax.vecmath.Point3d;
import jp.ac.nagoya_cu.sda.paper.shape.*;
import com.sun.j3d.utils.image.TextureLoader;


public class Paper extends BranchGroup{
	protected List<VertexPoint> vertices  = new ArrayList<VertexPoint>();
	protected List<EdgeLine> edges        = new ArrayList<EdgeLine>();
	protected List<FoldingLine> foldlines = new ArrayList<FoldingLine>();
	protected List<PlaneGeometry> planegeometrylist = new ArrayList<PlaneGeometry>();
	protected BranchGroup vpshapes    = new BranchGroup(); //؂
	protected BranchGroup planeshapes    = new BranchGroup();
	protected BranchGroup flshapes    = new BranchGroup(); //܂
	protected BranchGroup elshapes    = new BranchGroup(); //؂
	
	protected boolean lockGeometry=false;
	
	protected Shape3D shpPointDebug=new Shape3D();
	protected Appearance apr=null;
	protected Appearance apb=null;
	
	protected double width=0;
	protected double height=0;
	
//	protected Stack<PaperSnapShot> undoSnap=new Stack<PaperSnapShot>();
//	protected Stack<PaperSnapShot> redoSnap=new Stack<PaperSnapShot>();
	protected LinkedList<PaperSnapShot> snaplist=new LinkedList<PaperSnapShot>();
	protected int snappos=-1;

	public Paper(double width,double height,Component observer){
		
		this.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
		this.setCapability(BranchGroup.ENABLE_PICK_REPORTING);
		this.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
		this.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
		this.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
		this.setCapability(BranchGroup.ALLOW_LOCAL_TO_VWORLD_READ);
		
		apr=createAppearance(new Color3f(1,1,1),observer,true);
		apb=createAppearance(new Color3f(1,1,1),observer,false);

		this.width=width;
		this.height=height;
		
		PaperSnapShot snap=OriUtil.createSquarePaper(width,height);
		setPaper(snap);
		pushHistory();
		
		shpPointDebug.setPickable(false);
		shpPointDebug.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		Appearance ap=new Appearance();
		ap.setPointAttributes(new PointAttributes(4f,false));
		ap.setColoringAttributes(new ColoringAttributes(new Color3f(0,0,1),ColoringAttributes.FASTEST));
		shpPointDebug.setAppearance(ap);
		addChild(shpPointDebug);

	}
	
	public void setPaper(PaperSnapShot snap){
		this.vertices=snap.vertices;
		this.edges=snap.edges;
		this.foldlines=snap.foldlines;
		this.planegeometrylist=snap.planegeometrylist;
		
		for(int i=0;i<snap.geometry.size();i++){
			this.vertices.get(i).set(snap.geometry.get(i));
		}
		
		rebuildFoldingLine();
		rebuildEdgeLine();
		rebuildPlane();
		rebuildVertexPoint();
		
	}
	
	protected Appearance createAppearance(Color3f color,Component observer,boolean isRightside) {
		Appearance ap = new Appearance();

		Material mat = new Material();
		mat.setDiffuseColor(color);
		mat.setShininess(128f);
		
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(PolygonAttributes.POLYGON_FILL);
		pa.setBackFaceNormalFlip(true);
		
		if(isRightside){
			pa.setCullFace(PolygonAttributes.CULL_BACK);
			pa.setPolygonOffset(-0.1f);

			//eNX`
			TextureLoader txl = new TextureLoader(
					Paper.class.getResource("/back01.png"),
					TextureLoader.GENERATE_MIPMAP,
					observer);
			ap.setTexture(txl.getTexture());
			
			TextureAttributes ta=new TextureAttributes();
			ta.setTextureMode(TextureAttributes.MODULATE);
			ap.setTextureAttributes(ta);
		}else{
			pa.setCullFace(PolygonAttributes.CULL_FRONT);
			pa.setPolygonOffset(0.1f);
		}
		
		TransparencyAttributes ta=new TransparencyAttributes();
		ta.setTransparencyMode(TransparencyAttributes.NONE);

		ap.setMaterial(mat);
		ap.setPolygonAttributes(pa);
		ap.setTransparencyAttributes(ta);

		return ap;
	}

	public double getWidth(){
		return width;
	}
	public double getHeight(){
		return height;
	}

	
	/**
	 * IuWFNgɑ݂邷ׂĂLineԂ
	 * @return Iterator
	 */
	public Iterator<Line> getAllLines(){
//		return (new Iterator<Line>(){
//			private int findex=0,flen=foldlines.size();
//			private int eindex=0,elen=edges.size();
//			public boolean hasNext() {
//				return (findex<flen && eindex<elen);
//			}
//			public Line next() {
//				if(findex < flen){
//					return foldlines.get(findex++);
//				}else{
//					return edges.get(eindex++);
//				}
//			}
//			public void remove() {
//				throw new UnsupportedOperationException();
//			}
//		});
		ArrayList<Line> list=new ArrayList<Line>(foldlines.size()+edges.size());
		list.addAll(0,foldlines);
		list.addAll(foldlines.size(),edges);
		return list.iterator();
	}
	
	public Iterator<Plane> getAllPlanes(){
		return (new Iterator<Plane>(){
			Enumeration e=planeshapes.getAllChildren();
			public boolean hasNext() {
				return e.hasMoreElements();
			}
			public Plane next() {
				return (Plane)e.nextElement();
			}
			public void remove() {
				throw new UnsupportedOperationException();
			}
		});
	}

	public List<PlaneGeometry> getAllPlaneGeometries(){
		return planegeometrylist;
	}

	/**
	 * IuWFNgɑ݂邷ׂĂLineԂ
	 * @return Collection<Line>
	 */
	public Line[] getAllLineArray(){
		Line[] lns=new Line[edges.size()+foldlines.size()];
		Line[] le=new Line[edges.size()];
		Line[] lf=new Line[foldlines.size()];
		edges.toArray(le);
		foldlines.toArray(lf);
		System.arraycopy(le,0,lns,0,le.length);
		System.arraycopy(lf,0,lns,le.length,lf.length);
		return lns;
	}

	/**
	 * IuWFNgɑ݂ConnectPoints̖{Ԃ
	 * @return int {
	 */
	public int numLine(){
		return foldlines.size()+edges.size();
	}
	
	public VertexPoint getVertexPoint(int index){
		return vertices.get(index);
	}
	public List<VertexPoint> getAllVertexPoints(){
		return vertices;
	}
	public int numVertexPoints(){
		return vertices.size();
	}
	
	public int numPlane(){
		return planegeometrylist.size();
	}
	
	/**
	 * IuWFNgɑ݂邷ׂĂVerticesunlock
	 *
	 */
	public void unlockAllVertices(){
		for(int i=0;i<vertices.size();i++){
			vertices.get(i).unlock();
		}
	}
	
	/**
	 * zShape3D̃WIg킹B
	 *
	 */
	public void updateShape3D(){
		int plen = planeshapes.numChildren();
		for(int i=0;i<plen;i++){
			((Plane)planeshapes.getChild(i)).update();
		}
		int vplen = vpshapes.numChildren();
		for(int i=0;i<vplen;i++){
			((PointShape)vpshapes.getChild(i)).update();
		}
		int flen = flshapes.numChildren();
		for(int i=0;i<flen;i++){
			((LineShape)flshapes.getChild(i)).update();
		}
		int elen = elshapes.numChildren();
		for(int i=0;i<elen;i++){
			((LineShape)elshapes.getChild(i)).update();
		}
	}
	
	public Plane[] getAllConnectedPlanes(Line line){
		LinkedList<Plane> pls=new LinkedList<Plane>();
		Enumeration enu=planeshapes.getAllChildren();
		while(enu.hasMoreElements()){
			Plane plane=(Plane)enu.nextElement();
			List lines=plane.getPlaneGeometry().getAllLine();
			if(lines.contains(line)){
				pls.add(plane);
			}
		}
		
		Plane[] planes=new Plane[pls.size()];
		pls.toArray(planes);
		return planes;
	}
	
	public List<Line> getAllConnectedLines(VertexPoint vp){
		ArrayList<Line> llns=new ArrayList<Line>(this.numLine());
		for(Line ln:edges){
			if(ln.contain(vp)){
				llns.add(ln);
			}
		}
		for(Line ln:foldlines){
			if(ln.contain(vp)){
				llns.add(ln);
			}
		}
		llns.trimToSize();
		return llns;
	}
	
	public Plane getAnotherPlane(Line line,Plane plane){
		Enumeration e=planeshapes.getAllChildren();
		while(e.hasMoreElements()){
			Plane crrPlane=(Plane)e.nextElement();
			if(crrPlane != plane){
				for(Line crrLine:crrPlane.getPlaneGeometry().getAllLine()){
					if(crrLine == line){
						return crrPlane;
					}
				}
			}
		}
		return null;
	}
	
	public VertexPoint addVertexPoint(Point3d p3d,Point2d p2d){
		VertexPoint vp = new VertexPoint(p3d,p2d);
		vertices.add(vp);
		vpshapes.addChild(new PointShape(vp));
		return vp;
	}
	
	
	/**
	 * linepŕAɕlineɐڑĂPlaneXV
	 * @param line
	 * @param p
	 * @return
	 */
	public VertexPoint addVertexPointOnLine(Line line,Point3d p){
		//ڑĂPlaneQbg
		Plane[] cplanes=getAllConnectedPlanes(line);
		
		//PlaneGeometry[] pglist = new PlaneGeometry[plen]; // PlanẽWIgۑ
		List<List<Line>> linelist=new ArrayList<List<Line>>();
		
		//lineɐڂĂPlaneɂď
		for(Plane connectedPlane:cplanes){

			//̏ۑ
			linelist.add(new LinkedList<Line>(connectedPlane.getPlaneGeometry().getAllLine()));

			//Xg폜
			removePlane(connectedPlane);
			planegeometrylist.remove(connectedPlane.getPlaneGeometry());
		}
		
		//ŁAp܂ł̋̊_𐶐
		double d1=p.distance(line.getPointA());
		double d2=p.distance(line.getPointB());
		double dist=d1/(d1+d2);
		Point3d pnew=new Point3d();
		pnew.sub(line.getPointB(),line.getPointA());
		pnew.scaleAdd(dist,pnew,line.getPointA());
		
		Point2d pnew2d=new Point2d();
		pnew2d.sub(line.getPointB().getPoint2D(),line.getPointA().getPoint2D());
		pnew2d.scaleAdd(dist,line.getPointA().getPoint2D());
		
		VertexPoint vp=this.addVertexPoint(pnew,pnew2d); // VȒ_𐶐
		
		// ̒_ƐVȒ_Ԑ𐶐
		Line lineA,lineB;
		if(line instanceof FoldingLine){
			lineA=new FoldingLine(line.getPointA(),vp);
			lineB=new FoldingLine(line.getPointB(),vp);
			foldlines.add((FoldingLine)lineA);
			foldlines.add((FoldingLine)lineB);
		}
		else if(line instanceof EdgeLine){
			lineA=new EdgeLine(line.getPointA(),vp);
			lineB=new EdgeLine(line.getPointB(),vp);
			edges.add((EdgeLine)lineA);
			edges.add((EdgeLine)lineB);
		}else{
			throw new IllegalArgumentException("LinẽCX^XȌ^ł");
		}
		// ̐
		this.removeLine(line);
		
		
		// VȐ̐ɐڑ
		for(List<Line> lines:linelist){
			
			int pos=lines.indexOf(line);
			
			// я𒲐ăZbg
			if(pos<0){
				System.out.println("line݂ȂII");
			}
			else if(linedirection(lines,pos)){
				lines.set(pos,lineA);
				lines.add(pos+1,lineB);
			}else{
				lines.set(pos,lineB);
				lines.add(pos+1,lineA);
			}
			
			PlaneGeometry pgeometry =new PlaneGeometry(lines);

			// zɃZbg
			planegeometrylist.add(pgeometry);
			planeshapes.addChild(createNewPlaneShape(pgeometry));
		}
		
		rebuildFoldingLine();
		rebuildEdgeLine();
		//rebuildPlane();
		return vp;
	}
	
	private Line getRinged(List<Line> lines,int indexRinged){
		int i=0;
		while(indexRinged<0 && i++< 50){
			indexRinged += lines.size();
		}
		return lines.get(indexRinged%lines.size());
	}
	
	private boolean linedirection(List<Line> lines,int indexRinged){
		Line beforeln=getRinged(lines,indexRinged-1);
		Line ln=getRinged(lines,indexRinged);
		if(beforeln.contain(ln.getPointA())){
			return true;
		}else if(beforeln.contain(ln.getPointB())){
			return false;
		}else{
			System.out.println("ӂȂĂȂII");
			return false;
		}
	}
	
	public Line removeLine(Line line){
		if(line instanceof FoldingLine){
			boolean r=foldlines.remove(line);
			if(r){
				return line;
			} else{
				System.out.println("removeLine:w肳ꂽLine݂͑܂");
				return null;
			}
		}
		else if(line instanceof EdgeLine){
			boolean r=edges.remove(line);
			if(r){
				return line;
			} else{
				System.out.println("removeLine:w肳ꂽLine݂͑܂");
				return null;
			}
		}else{
			System.out.println("removeLine:Ȃ񂩂II");
		}
		return null;
	}
	
	public FoldingLine addFoldingLine(VertexPoint p1,VertexPoint p2){
		
		// ^ꂽ_ԂԐłɂȂׂ
		List<Line> lns = getAllConnectedLines(p1);
		for(Line cp:lns){
			if(cp.getAnotherPoint(p1).equals(p2)){
				System.out.println("^ꂽ_ԂԐłɑ݂Ă܂");
				//throw new IllegalArgumentException();
				return null;
			}
		}
		
		// zgAɒǉ
		FoldingLine fl = new FoldingLine(p1,p2);
		foldlines.add(fl);

		rebuildFoldingLine();
		
		return fl;
	}
	
	protected void removePlane(Plane plane){
		planeshapes.removeChild(plane);
		PlaneGeometry pg=plane.getPlaneGeometry();
		planegeometrylist.remove(pg);
	}
	
	protected Plane createNewPlaneShape(PlaneGeometry planegeometry){
		Plane plane = new Plane(planegeometry);
		plane.setRightsideAppearance(apr);
		plane.setBacksideAppearance(apb);
		return plane;
	}
	protected void rebuildVertexPoint(){
		BranchGroup bg = createBG();
		Iterator<VertexPoint> ip = vertices.iterator();
		while(ip.hasNext()){
			VertexPoint vp = ip.next();
			bg.addChild(new PointShape(vp));
		}
		this.addChild(bg);
		vpshapes.detach();
		vpshapes=bg;
	}
	
	protected void rebuildPlane(){
		BranchGroup bg = createBG();
		Iterator<PlaneGeometry> ip = planegeometrylist.iterator();
		while(ip.hasNext()){
			PlaneGeometry lines = ip.next();
			bg.addChild(createNewPlaneShape(lines));
		}
		this.addChild(bg);
		planeshapes.detach();
		planeshapes=bg;
	}
	
	protected void rebuildFoldingLine(){
		BranchGroup bg = createBG();
		Iterator<FoldingLine> ifl = foldlines.iterator();
		while(ifl.hasNext()){
			LineShape ls=new LineShape(ifl.next());
			//ls.setAppearance(OriUtil.createLineAppearance(new Color3f(.8f,.8f,.8f),1,LineAttributes.PATTERN_SOLID));
			bg.addChild(ls);
		}
		this.addChild(bg);
		flshapes.detach();
		flshapes=bg;
	}
	
	protected void rebuildEdgeLine(){
		BranchGroup bg = createBG();
		Iterator<EdgeLine> ifl = edges.iterator();
		while(ifl.hasNext()){
			LineShape ls=new LineShape(ifl.next());
			bg.addChild(ls);
		}
		this.addChild(bg);
		elshapes.detach();
		elshapes=bg;
	}
	private BranchGroup createBG(){
		BranchGroup bg = new BranchGroup();
		bg.setCapability(BranchGroup.ALLOW_CHILDREN_READ);
		bg.setCapability(BranchGroup.ALLOW_CHILDREN_WRITE);
		bg.setCapability(BranchGroup.ALLOW_CHILDREN_EXTEND);
		bg.setCapability(BranchGroup.ALLOW_DETACH);
		return bg;	
	}
	
	public void splitPlane(Plane plane,VertexPoint vp1,VertexPoint vp2){
		List<VertexPoint> vps = Arrays.asList(plane.getPlaneGeometry().getAllVertexPoints());
		int v1=vps.indexOf(vp1);
		int v2=vps.indexOf(vp2);
		if(v1>=0 && v2>=0){
			splitPlane(plane,v1,v2);
		}else{
			throw new IllegalArgumentException("VertexPointPlaneɑ݂܂ "+v1+" "+v2);
		}
	}
	public void splitPlane(Plane plane,int vp1,int vp2){
		
		List<VertexPoint> vps = Arrays.asList(plane.getPlaneGeometry().getAllVertexPoints());
		PlaneGeometry pg = plane.getPlaneGeometry();
		
		FoldingLine fl = addFoldingLine(vps.get(vp1),vps.get(vp2));
		if(fl==null){
			return;
		}
		int p1 = vps.indexOf(fl.getPointA());
		int p2 = vps.indexOf(fl.getPointB());
		
		int flpos_a = Math.min(p1,p2);
		int flpos_b = Math.max(p1,p2);
		
		LinkedList<Line> ln1=new LinkedList<Line>();
		ln1.add(fl);
		for(int i=0;i<flpos_b-flpos_a;i++){
			ln1.add(pg.getRinged(i+flpos_a));
		}
		
		LinkedList<Line> ln2=new LinkedList<Line>();
		ln2.add(fl);
		for(int i=0;i<pg.getAllLine().size()+flpos_a-flpos_b;i++){
			ln2.add(pg.getRinged(flpos_b+i));
		}
		PlaneGeometry pg1 = new PlaneGeometry(ln1);
		PlaneGeometry pg2 = new PlaneGeometry(ln2);
		
		planegeometrylist.remove(pg);
		planegeometrylist.add(pg1);
		planegeometrylist.add(pg2);

		planeshapes.removeChild(plane);
		planeshapes.addChild(createNewPlaneShape(pg1));
		planeshapes.addChild(createNewPlaneShape(pg2));
		
	}
	
	
	public void cutPlane(Plane plane,int vp1,VertexPoint vp){
		if(!this.vertices.contains(vp)){
			throw new IllegalArgumentException("VertexPoint vpIuWFNgɑ݂܂");
		}
		
		VertexPoint[] vps = plane.getPlaneGeometry().getAllVertexPoints();
		List<Line> pg = plane.getPlaneGeometry().getAllLine();
		
		FoldingLine fl = addFoldingLine(vps[vp1],vp);
		if(fl==null){
			return ;
		}

		LinkedList<Line> newln=new LinkedList<Line>();
		for(int i=0;i<pg.size();i++){
			if(i==vp1){
				newln.add(fl);	// s
				newln.add(fl);	// A
			}
			newln.add(pg.get(i));
		}
		PlaneGeometry newpg = new PlaneGeometry(newln);
		
		planegeometrylist.remove(pg);
		planegeometrylist.add(newpg);
		
		planeshapes.removeChild(plane);
		planeshapes.addChild(createNewPlaneShape(newpg));
		
	}
	
	public void debugPirntPoint(Point3d p){
		PointArray g=new PointArray(1,PointArray.COORDINATES);
		g.setCoordinate(0,p);
		shpPointDebug.addGeometry(g);
	}

	
	/**
	 * ݂Paper\vf̔zRs[B
	 * @param vertices
	 * @param edges
	 * @param foldlines
	 * @param planegeometrylist
	 */
	protected PaperSnapShot createSnapShot(){
		PaperSnapShot snap=new PaperSnapShot(
				this.vertices,
				this.edges,
				this.foldlines,
				this.planegeometrylist);
		return snap;
	}
	
	public void pushHistory(){
		if(snappos >= snaplist.size()){
			System.out.println("qXg[̐I");
		}
		while(snappos+1<snaplist.size()){
			snaplist.removeLast();
		}
		snaplist.add(createSnapShot());
		snappos++;
		System.out.println("Push to History");
	}
	public void undo(){
		snappos--;
		if(snappos<0){
			System.out.println("Can not Undo!");
			snappos=0;
		}
		PaperSnapShot snap=snaplist.get(snappos);
		setPaper(snap);
	}
	public void redo(){
		snappos++;
		if(snappos>=snaplist.size()){
			System.out.println("Can not Redo!");
			snappos=snaplist.size()-1;
		}
		PaperSnapShot snap=snaplist.get(snappos);
		setPaper(snap);
	}
	
}
