package jp.ac.nagoya_cu.sda.paper;

import javax.vecmath.Point3d;
import javax.vecmath.Tuple3d;
import javax.vecmath.Vector3d;

public class Triangle {
	public Point3d p0,p1,p2;

	public Triangle(){
		
	}
	
	public Triangle(Point3d[] vs) {
		set(vs);
	}	
	public Triangle(Point3d p0,Point3d p1,Point3d p2) {
		set(p0,p1,p2);
	}
	public Triangle(Triangle src) {
		set(src.p0,src.p1,src.p2);
	}
	
	
	
	
	
	public void set(Point3d[] vs) {
		set(vs[0],vs[1],vs[2]);
	}
	public void set(Triangle src){
		set(src.p0,src.p1,src.p2);
	}
	
	public void set(Point3d p0,Point3d p1,Point3d p2) {
		this.p0=(p0);
		this.p1=(p1);
		this.p2=(p2);
	}
	
	/**
	 * O_ׂĊ܂ޖʂƐŁAKꂽxNgԂ
	 * @param p0
	 * @param p1
	 * @param p2
	 * @return
	 */
	public static Vector3d createNormal(Point3d p0,Point3d p1,Point3d p2){
		Vector3d vvA = new Vector3d();
		Vector3d vvB = new Vector3d();
		vvA.sub(p1,p0);
		vvB.sub(p2,p0);
		vvA.cross(vvA, vvB);
		vvA.normalize();
		return(vvA);	
	}
	
	public Vector3d createNormal(){
		return createNormal(p0,p1,p2);
	}
	
	public static double createDistance(Point3d p0,Point3d p1,Point3d p2){
		return dot(createNormal(p0,p1,p2),p0);
	}
	public double createDistance(){
		return dot(createNormal(p0,p1,p2),p0);
	}
	
	
	
	/**
	 * Op`ƐƂ̌_߂
	 * @param pstart ̎n_
	 * @param pend ̏I_
	 * @return Op`Ƃ̌_B_Op`̗̈ɂȂnullB
	 */
	public Point3d intersectSegmentPoint(Point3d pstart,Point3d pend){
		// ̗[ʂ̂ǂ瑤ɂ邩ׂ
		if (isRightSide(pstart) != isRightSide(pend)) {

			Vector3d vecD = new Vector3d(); // xNg
			vecD.sub(pend, pstart);
			
			Point3d crossPoint=intersect(pstart,vecD);

			// ̈܂͋E߂ɂȂ
			if (isInside(crossPoint)) {
				return crossPoint;
			}
		}
		return null;
	}
	
	/**
	 * 3_܂ޕʂƁAxNǧ_߂
	 * @param pstart ̎n_
	 * @param direction ̕B͕ԒlɉeȂB
	 * @return ʂƂ̌_B
	 */
	public Point3d intersect(Point3d pstart,Vector3d direction){
		double distance=createDistance();
		Vector3d normal=createNormal();
		double t = (distance - dot(normal,pstart))/ normal.dot(direction);
		Point3d crossPoint = new Point3d();
		crossPoint.scaleAdd(t, direction, pstart);
		return crossPoint;
	}
	
	/**
	 * Op`̗̈ŁA_ł߂ʒuԂ
	 * @param p
	 * @return
	 */
	public Point3d getClosestPoint(Point3d p){
		
		Point3d pCross=getClosestPointInPlane(p);

		if (isInside(pCross)) {
			//_̈̏ꍇ͂̓_gł߂_
			return pCross;
		}else{
			//̈Ȍꍇ͕ӂƂ̋߂_
			return getClosestPointOnSegments(p);
		}

	}
	
	/**
	 * Op`\ƁA^ꂽ_Ƃ̋Ԃ
	 * @param p
	 * @return
	 */
	public Point3d getClosestPointOnSegments(Point3d p){
		Point3d[] pl=new Point3d[3];
		pl[0]=Line.closestPoint(p0,p1,p);
		pl[1]=Line.closestPoint(p1,p2,p);
		pl[2]=Line.closestPoint(p2,p0,p);
		
		double min=Double.MAX_VALUE;
		Point3d pr=null;
		for(int i=0;i<pl.length;i++){
			if(p.distanceSquared(pl[i]) < min){
				min=p.distanceSquared(pl[i]);
				pr=pl[i];
			}
		}
		return pr;
	}
	
	/**
	 * _AOp`̕ӂň͂܂A@ɐLт̈ɂ邩ǂ
	 * @param p
	 * @return
	 */
	public boolean isInside(Point3d p){
		Vector3d normal=createNormal();
		double s1 = getCross(normal, p, p0,p1);
		double s2 = getCross(normal, p, p1,p2);
		double s3 = getCross(normal, p, p2,p0);
		return (s1 * s2 > 0 && s1 * s3 > 0);
	}
	private double getCross(Vector3d N, Point3d pc, Point3d p1, Point3d p2) {
		Vector3d vvA = new Vector3d();
		Vector3d vvB = new Vector3d();
		vvA.sub(p2, p1);
		vvB.sub(pc, p1);
		vvA.cross(vvA, vvB);
		return N.dot(vvA);
	}

	
	/**
	 * Op`܂ޕʏŁA^ꂽ_ł߂ʒu߂
	 * @param p
	 * @return
	 */
	public Point3d getClosestPointInPlane(Point3d p){
		if(p0==p||p1==p||p2==p){
			return p;
		}
		Vector3d normal=createNormal();
		Vector3d vecD = new Vector3d(); // xNg
		vecD.sub(p, p0);
		Point3d crossPoint = new Point3d();
		crossPoint.scaleAdd(-1*vecD.dot(normal),normal,p);
		return crossPoint;
	}
	
	/**
	 * ʂ̖@\ƂƂA_\ɂ邩ǂ
	 * @param p
	 * @return
	 */
	public boolean isRightSide(Tuple3d p){
		double distance=createDistance();
		Vector3d normal=createNormal();
		double wA = dot(normal,p) - distance;
		return (wA > 0);
	}

	
	private static double dot(Tuple3d v1, Tuple3d v2){
		return v1.x*v2.x+v1.y*v2.y+v1.z*v2.z;
	}
	
	/**
	 * Op`̏dS߂
	 * @return
	 */
	public Point3d centroid(){
		Point3d p=new Point3d();
		p.sub(p1,p0);
		Point3d tmp=new Point3d();
		tmp.sub(p2,p1);
		p.scaleAdd(1/2d,tmp);
		p.scale(2d/3d);
		p.add(p0);
		return p;
	}
	
	/**
	 * Op`̊OS߂BܐS̒ňԍ
	 * @return
	 */
	public Point3d circumcenter(){
		Point3d p=new Point3d();
		p.add(p0);
		p.add(p1);
		p.add(p2);
		p.scale(1/3d);
		return p;
	}
	
	/**
	 * Op`̓S߂
	 * @return
	 */
	public Point3d incenter(){
		Vector3d v1=new Vector3d();
		Vector3d v2=new Vector3d();
		v1.sub(p1,p0);
		v2.sub(p2,p0);
		Vector3d v3=new Vector3d();
		v3.scaleAdd(v2.length()/(v1.length()+v2.length()),v1);
		v3.scaleAdd(v1.length()/(v1.length()+v2.length()),v2);
		
		Point3d p=new Point3d();
		v2.sub(v3,v1);
		p.scaleAdd(v1.length()/(v1.length()+v2.length()),v2);
		p.scaleAdd(v2.length()/(v1.length()+v2.length()),v1);
		
		return p;
	}
}
