package jp.ac.nagoya_cu.sda.paper.behavior;

import java.awt.AWTEvent;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;
import java.util.Enumeration;
import javax.media.j3d.WakeupCriterion;
import javax.media.j3d.WakeupOnAWTEvent;
import javax.media.j3d.WakeupOr;
import javax.media.j3d.Behavior;

public abstract class MouseBehavior extends Behavior{
	protected WakeupOr wakeupCondition;

	public void initialize() {
		// }EXƂAƂAhbOƂ
		// N
		WakeupCriterion[] conditions = new WakeupCriterion[4];
		conditions[0] = new WakeupOnAWTEvent(MouseEvent.MOUSE_MOVED);
		conditions[1] = new WakeupOnAWTEvent(MouseEvent.MOUSE_DRAGGED);
		conditions[2] = new WakeupOnAWTEvent(MouseEvent.MOUSE_PRESSED);
		conditions[3] = new WakeupOnAWTEvent(MouseEvent.MOUSE_RELEASED);
		wakeupCondition = new WakeupOr(conditions);
		wakeupOn(wakeupCondition);
	}
	public void processStimulus(Enumeration criteria) {
		WakeupCriterion wakeup;

	// AWTEvent o
	while (criteria.hasMoreElements()) {
		wakeup = (WakeupCriterion) criteria.nextElement();
		if (wakeup instanceof WakeupOnAWTEvent){
			for(AWTEvent evt:((WakeupOnAWTEvent) wakeup).getAWTEvent()){
				// MouseEvent ̏ꍇ
				if (evt instanceof MouseEvent) {
					MouseEvent mevent = (MouseEvent) evt;

					switch (mevent.getID()) {
					case MouseEvent.MOUSE_PRESSED:
						onMousePressed(mevent);
						break;
					case MouseEvent.MOUSE_RELEASED:
						onMouseReleased(mevent);
						break;
					case MouseEvent.MOUSE_DRAGGED:
						onMouseDragged(mevent);
						break;
					case MouseEvent.MOUSE_MOVED:
						onMouseMoved(mevent);
						break;
					default:
					}
				}
				
			}
		}
		
	}

	wakeupOn(wakeupCondition);
}

	public void onMousePressed(MouseEvent mevent){
		
	}
	public void onMouseReleased(MouseEvent mevent){
		
	}
	public void onMouseDragged(MouseEvent mevent){
		
	}
	public void onMouseMoved(MouseEvent mevent){
		
	}
	
	
	/**
	 * Ɏw肵InputEventCtrlAShiftAAltL[̏Ԃ݂̂o
	 * @param evt
	 * @return Ⴆ΂CtrlL[̂݉ĂꍇInputEvent.CTRL_DOWN_MASKB
	 */
	protected static int getCtrlShiftAlt(InputEvent evt){
		int status=0;
		int e=evt.getModifiersEx();
		status += e & InputEvent.CTRL_DOWN_MASK;
		status += e & InputEvent.SHIFT_DOWN_MASK;
		status += e & InputEvent.ALT_DOWN_MASK;
		return status;
	}
	
	protected static int getMouseButtonStatus(InputEvent evt){
		int status=0;
		int e=evt.getModifiersEx();
		status+=e&InputEvent.BUTTON1_DOWN_MASK;
		status+=e&InputEvent.BUTTON2_DOWN_MASK;
		status+=e&InputEvent.BUTTON3_DOWN_MASK;
		return status;
	}

}
