package jp.ac.nagoya_cu.sda.paper.behavior;

import java.awt.event.KeyEvent;
import javax.media.j3d.*;
import javax.vecmath.*;

import jp.ac.nagoya_cu.sda.paper.*;

public class PressBehavior extends KeyMouseBehavior{
	protected Paper paper=null;
	protected boolean isPress=false;
	
	public PressBehavior(Paper paper,Bounds bounds){
		setSchedulingBounds(bounds);
		this.paper=paper;
	}

	
	
	public void onKeyPressed(KeyEvent kevent){
		int code = kevent.getKeyCode();
		switch (code) {
		case KeyEvent.VK_SPACE:
			press();
			isPress = true;
			break;
		}
	}
	public void onKeyReleased(KeyEvent kevent){
		if(isPress){
			paper.pushHistory();
		}
		isPress=false;
	}
	
	protected void press(){
		Transform3D t3dLV=new Transform3D();
		Transform3D t3dVL=new Transform3D();
		paper.getLocalToVworld(t3dLV);
		paper.getLocalToVworld(t3dVL);
		t3dVL.invert();
		
		
		double margin=0.00;
		
		for(VertexPoint vp:paper.getAllVertexPoints()){

			Point3d newVp=new Point3d(vp);
			t3dLV.transform(newVp);

			if(Math.abs(newVp.z)<margin){

			}else if(newVp.z>0){
				newVp.z=(newVp.z-margin)*2/3d;
			}else{
				newVp.z=(newVp.z+margin)*2/3d;
			}
			
			t3dVL.transform(newVp);
			vp.set(newVp);
			
		}
	}

}
