package jp.ac.nagoya_cu.sda.paper.behavior;

import jp.ac.nagoya_cu.sda.paper.*;
import jp.ac.nagoya_cu.sda.paper.shape.*;

import com.sun.j3d.utils.picking.*;
import java.awt.event.*;
import java.util.*;
import java.util.List;

import javax.media.j3d.*;
import javax.vecmath.*;

public class createFoldingLineBehavior extends MouseBehavior {

	protected Canvas3D canvas = null;
	protected Paper paper;
	protected Group root;
	protected PickCanvas pickCanvas=null;
	protected boolean isDraw=false;
	
	protected Point3d pStart=new Point3d();
	protected Point3d pEnd = new Point3d();
	protected OrigamiShape shpStart=null;
	protected OrigamiShape shpEnd=null;
	protected List<OrigamiShape> shpStartList=new ArrayList<OrigamiShape>();
	protected List<OrigamiShape> shpEndList=new ArrayList<OrigamiShape>();
	
	protected Shape3D shpSelectedLines=new Shape3D();
	protected Shape3D shpSelectedPoints =new Shape3D();
	protected Shape3D shpCutLine =new Shape3D();
	protected Shape3D shpCrossPoints = new Shape3D();
	protected Shape3D shpPointsAx = new Shape3D();
	protected Shape3D shpLinesAx = new Shape3D();
	
	protected Appearance apCutPossible=OriUtil.createLineAppearance(new Color3f(0,1,1),4,LineAttributes.PATTERN_SOLID);
	protected Appearance apCutImpossible=OriUtil.createLineAppearance(new Color3f(0,1,1),4,LineAttributes.PATTERN_DASH);

	public createFoldingLineBehavior(Canvas3D canvas, Group root, Bounds bounds) {
		setSchedulingBounds(bounds);

		this.canvas = canvas;
		this.root = root;

		addShapeToRoot(shpCutLine,apCutImpossible);
		addShapeToRoot(shpCrossPoints,OriUtil.createPointAppearance(new Color3f(1,.5f,.5f),10));
		addShapeToRoot(shpSelectedLines,OriUtil.createLineAppearance(new Color3f(0,1,0),4,LineAttributes.PATTERN_SOLID));
		addShapeToRoot(shpSelectedPoints,OriUtil.createPointAppearance(new Color3f(1,.5f,.5f),12));
		addShapeToRoot(shpPointsAx,OriUtil.createPointAppearance(new Color3f(1,0,0),12));
		addShapeToRoot(shpLinesAx,OriUtil.createLineAppearance(new Color3f(1,.8f,0),6,LineAttributes.PATTERN_SOLID));
	}

	public void setPaper(Paper p) {
		this.paper = p;
		this.pickCanvas=new PickCanvas(canvas,paper);
		pickCanvas.setMode(PickTool.GEOMETRY_INTERSECT_INFO);
		pickCanvas.setTolerance(6f);
		
	}

	
	
	
	
	
	public void onMousePressed(MouseEvent mevent){
		if (getMouseButtonStatus(mevent)==MouseEvent.BUTTON3_DOWN_MASK) {
			isDraw = true;
			shpStart=setPoint(mevent,pStart,shpStartList);
		}else{
			isDraw = false;
		}
	}
	public void onMouseReleased(MouseEvent mevent){
		showReset();
		if(isDraw){
			shpCutLine.setGeometry(null);
			boolean isChanged=createFoldingLines(true);
			if(isChanged){
				paper.pushHistory();
			}
		}
		isDraw = false;
	}
	public void onMouseDragged(MouseEvent mevent){
		if (getMouseButtonStatus(mevent)==MouseEvent.BUTTON3_DOWN_MASK) {
			showSelectedOrigamiShape(mevent);
			shpEnd=setPoint(mevent,pEnd,shpEndList);
			showLine(shpCutLine,pStart,pEnd);
			createFoldingLines(false);
		}
	}
	public void onMouseMoved(MouseEvent mevent) {
		showSelectedOrigamiShape(mevent);
	}
	
	
	
	
	
	
	
	/**
	 * NbN_̍WƃIuWFNgi[
	 * @param mevent
	 * @param p3d
	 * @param shpOrigami
	 */
	private OrigamiShape setPoint(MouseEvent mevent,Point3d p3d,List<OrigamiShape> shpList){
		pickCanvas.setShapeLocation(mevent);
		PickResult[] res = pickCanvas.pickAllSorted();
		p3d.set(OriUtil.getPickedLocationVW(canvas,mevent.getPoint(),res));
		OrigamiShape shpOrigami=OriUtil.getPickedOrigamiShape(res);
		shpList.clear();
		shpList.addAll(OriUtil.getAllPickedOrigamiShapes(res,shpOrigami));
		
		if(shpStart instanceof PointShape){
			PointShape ls=(PointShape)shpStart;
			Point3d pnew=ApproximationPointVW(ls.getPoint(),p3d);
			if(!pnew.equals(p3d)){
				p3d.set(pnew);
				return shpOrigami;
			}
		}
		
		if (shpOrigami instanceof PointShape) {

		}
		else if (shpOrigami instanceof LineShape) {
			LineShape ls=(LineShape)shpOrigami;
			p3d.set(ApproximationLineVW(ls.getLine(),p3d));//_ߎ
		}
		return shpOrigami;
	}
	
	/**
	 * }EX悳ꂽIuWFNgnCCg
	 * @param mevent
	 */
	private void showSelectedOrigamiShape(MouseEvent mevent){
		showReset();
		pickCanvas.setShapeLocation(mevent);
		PickResult[] res = pickCanvas.pickAllSorted();
		OrigamiShape shp=OriUtil.getPickedOrigamiShape(res);
		Point3d crrPt=OriUtil.getPickedLocationVW(canvas,mevent.getPoint(),res);
		if (shp instanceof PointShape) {
			PointShape pshp=(PointShape)shp;
			showSelectedPoint(pshp.getPoint());
		}
		else if (shp instanceof LineShape) {
			LineShape ls=(LineShape)shp;
			showSelectedLine(ls.getLine());
			ApproximationLineVW(ls.getLine(),crrPt);
		}
	}
	
	/**
	 * w肳ꂽ_nCCg
	 */
	private void showSelectedPoint(VertexPoint vp){
		Transform3D t3d=new Transform3D();
		paper.getLocalToVworld(t3d);
		Point3d p=new Point3d(vp);
		t3d.transform(p);
		PointArray g=new PointArray(1,PointArray.COORDINATES);
		g.setCoordinate(0,OriUtil.getShortPointVW(canvas,p));
		shpSelectedPoints.setGeometry(g);
	}
	
	/**
	 * w肳ꂽLinenCCg
	 */
	private void showSelectedLine(Line line){
		Transform3D t3d=new Transform3D();
		line.getLineShape().getLocalToVworld(t3d);
		Point3d p1=new Point3d(line.getPointA());
		Point3d p2=new Point3d(line.getPointB());
		t3d.transform(p1);
		t3d.transform(p2);
		showLine(shpSelectedLines,p1,p2);
	}
	
	/**
	 * w肳ꂽ_Ɠ_OłȂ
	 * @param lshape
	 * @param p0
	 * @param p1
	 */
	private void showLine(Shape3D lshape,Point3d p0,Point3d p1){
		LineArray g=new LineArray(2,LineArray.COORDINATES);
		g.setCoordinate(0,OriUtil.getShortPointVW(canvas,p0));
		g.setCoordinate(1,OriUtil.getShortPointVW(canvas,p1));
		lshape.setGeometry(g);
	}
	
	/**
	 * IuWFNg̃nCCgZbg
	 */
	private void showReset(){
		shpSelectedPoints.setGeometry(null);
		shpSelectedLines.setGeometry(null);
		shpCutLine.setGeometry(null);
		shpCrossPoints.setGeometry(null);
		shpPointsAx.setGeometry(null);
		shpLinesAx.setGeometry(null);
	}
	
	protected boolean createFoldingLines(boolean cutExecute){

		//_AI_ֈړ
		Point3d pA=new Point3d();
		Point3d pB=new Point3d();
		Point3d pEye=OriUtil.getCenterEyePosVW(canvas);
		pA.sub(pStart,pEye);
		pB.sub(pEnd,pEye);
		pA.scaleAdd(100,pEye);
		pB.scaleAdd(100,pEye);
		
		//[JW
		Transform3D t3dVL=new Transform3D();
		paper.getLocalToVworld(t3dVL);
		t3dVL.invert();
		t3dVL.transform(pEye);
		t3dVL.transform(pA);
		t3dVL.transform(pB);
		
		List<Line> listLine=new ArrayList<Line>();	//i[
		List<Point3d> listPoint=new ArrayList<Point3d>();	//_i[

		//ԂJbg3p`𐶐
		Triangle trCut=new Triangle(pEye,pA,pB);
		

		
		List<Line> alllines=new LinkedList<Line>(Arrays.asList(paper.getAllLineArray()));
		
		//n_AI_͂̂
		removeEdgeLine(alllines,shpStartList);
		removeEdgeLine(alllines,shpEndList);
		
		//s
		for(Line line:alllines){
			Point3d pcross=trCut.intersectSegmentPoint(line.getPointA(),line.getPointB());
			if(pcross != null){
				listLine.add(line);
				listPoint.add(pcross);
			}
		}
		
		//ʏ̌_ɓ_ǉ
		shpCrossPoints.setGeometry(null);
		if(listPoint.size()>0){
			PointArray plist=new PointArray(listPoint.size(),PointArray.COORDINATES);
			Transform3D t3d=new Transform3D();
			paper.getLocalToVworld(t3d);
			for(int i=0;i<listPoint.size();i++){
				Point3d p=new Point3d(listPoint.get(i));
				t3d.transform(p);
				plist.setCoordinate(i,p);
			}
			shpCrossPoints.setGeometry(plist);
		}

		//ؒf\ǂ
		int lenCrossPoint=listPoint.size();
		if(shpStart instanceof PointShape || shpStart instanceof LineShape){
			lenCrossPoint++;
		}
		if(shpEnd instanceof PointShape || shpEnd instanceof LineShape){
			lenCrossPoint++;
		}
		if(lenCrossPoint<2){
			shpCutLine.setAppearance(apCutImpossible);
		}else{
			shpCutLine.setAppearance(apCutPossible);
		}

		
		//ۂɖʂؒf
		boolean isChanged=false;
		if(cutExecute){
			List<VertexPoint> listNewVp=new ArrayList<VertexPoint>();

			//Ƃ̌_ɒ_ǉ
			for(int i=0;i<listPoint.size();i++){
				Line line=listLine.get(i);
				Point3d p=listPoint.get(i);
				VertexPoint vp=null;
//				//̏I_߂ɂ͒_VɍȂ
//				double margin=1e-5;
//				if(p.distanceSquared(line.getPointA())<margin){
//					vp=line.getPointA();
//				}else if(p.distanceSquared(line.getPointB())<margin){
//					vp=line.getPointB();
//				}else{
					vp=paper.addVertexPointOnLine(line,p);
					isChanged=true;
//				}
				if(!listNewVp.contains(vp)){
					listNewVp.add(vp);
				}
			}
			
			//n_ƏI_ǉ
			addEdgeVertexPoints(listNewVp,shpStartList,pStart);
			addEdgeVertexPoints(listNewVp,shpEndList,pEnd);
			
			//܂ڐ
			for(int i=0;i<listNewVp.size()-1;i++){
				for(int j=i+1;j<listNewVp.size();j++){
					VertexPoint vp1=listNewVp.get(i),vp2=listNewVp.get(j);
					Plane plane=getConnectablePlane(vp1,vp2);
					if(plane!=null){
						paper.splitPlane(plane,vp1,vp2);
						isChanged=true;
					}
				}
			}
		}
		return isChanged;
	}
	private Plane getConnectablePlane(VertexPoint p1,VertexPoint p2){
		Iterator<Plane> it=paper.getAllPlanes();
		while(it.hasNext()){
			Plane plane=it.next();
			List<VertexPoint> vps=Arrays.asList(plane.getPlaneGeometry().getAllVertexPoints());
			if(vps.contains(p1) && vps.contains(p2)){
				return plane;
			}
		}
		return null;
	}
	private void addEdgeVertexPoints(List<VertexPoint> vpl,List<OrigamiShape> shpList,Point3d p){
		for(OrigamiShape shp:shpList){
			VertexPoint vp=getEdgeVertexPoint(shp,p);
			if(vp!=null){
				vpl.add(vp);
			}
		}
	}
	private VertexPoint getEdgeVertexPoint(OrigamiShape shp,Point3d p){
		if(shp instanceof PointShape){
			PointShape ps=(PointShape)shp;
			return ps.getPoint();
		}else if(shp instanceof LineShape){
			Point3d pnew=new Point3d(p);
			LineShape shape=(LineShape)shp;
			Transform3D t3d=new Transform3D();
			paper.getLocalToVworld(t3d);
			t3d.invert();
			t3d.transform(pnew);
			VertexPoint vp=paper.addVertexPointOnLine(shape.getLine(),pnew);
			return vp;
		}
		return null;
	}
	private void removeEdgeLine(List<Line> lines,List<OrigamiShape> shpList){
		for(OrigamiShape shape:shpList){
			if(shape instanceof PointShape){
				PointShape shp=(PointShape)shape;
				lines.removeAll(paper.getAllConnectedLines(shp.getPoint()));
			}
			if(shape instanceof LineShape){
				LineShape shp=(LineShape)shape;
				lines.remove(shp.getLine());
			}
		}
	}
	
	
	
	
	

	//Shape3Drootɒǉ
	private void addShapeToRoot(Shape3D shp,Appearance ap){
		shp.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		shp.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
		shp.setPickable(false);
		shp.setAppearance(ap);
		this.root.addChild(shp);
	}
	
	

	/**
	 * Line̓_Line𓙕ꍇ͋ߎ
	 */
	private Point3d ApproximationLineVW(Line line,Point3d p){
		int[] ds={2,4,3};
		for(int d:ds){
			Point3d ps=_ApproximationLineVW(line,p,d);
			if(ps!=null){
				return ps;
			}
		}
		return p;
	}	
	private Point3d _ApproximationLineVW(Line line,Point3d p,int d){
		double delta=line.length()/20d;
		delta*=delta;
		
		Vector3d v=line.createDirection();
		Point3d pstart=line.createStartPoint();
		Point3d pr=null;
		
		Transform3D t3d=new Transform3D();
		line.getLineShape().getLocalToVworld(t3d);
		
		t3d.transform(v);
		t3d.transform(pstart);
		
		shpPointsAx.setGeometry(null);

		PointArray g=new PointArray(d-1,PointArray.COORDINATES);
		for(int i=0;i<d-1;i++){
			Point3d ps=new Point3d();
			ps.scaleAdd(1d/d*(i+1),v,pstart);
			if(ps.distanceSquared(p)<delta){
				pr= ps;
			}
			g.setCoordinate(i,ps);
		}
		if(pr!=null){
			shpPointsAx.setGeometry(g);
			return pr;
		}else{
			return null;
		}
	}
	
	private Point3d ApproximationPointVW(VertexPoint vp,Point3d pv){
		Transform3D t3dVL=new Transform3D();
		Transform3D t3dLV=new Transform3D();
		paper.getLocalToVworld(t3dVL);
		paper.getLocalToVworld(t3dLV);
		t3dVL.invert();
		
		Point3d crrPt=new Point3d(pv);
		t3dVL.transform(crrPt);
		
		//߂{擾
		lineDistanceComp lcomp=new lineDistanceComp(crrPt);
		List<Line> clines=paper.getAllConnectedLines(vp);
		Collections.sort(clines,lcomp);
		List<Line> closestLines=clines.subList(0,2);
		
		//O[oW
		Point3d p0v=new Point3d(vp);
		Point3d p1v=new Point3d(closestLines.get(0).getAnotherPoint(vp));
		Point3d p2v=new Point3d(closestLines.get(1).getAnotherPoint(vp));
		t3dLV.transform(p0v);
		t3dLV.transform(p1v);
		t3dLV.transform(p2v);
		
		//݂̓_{̐Ɠʏ
		Vector3d vcrrPtv=new Vector3d();
		Point3d peye=OriUtil.getCenterEyePosVW(canvas);
		vcrrPtv.sub(pv,peye);
		Triangle tr=new Triangle(p0v,p1v,p2v);
		Point3d crrPtv=tr.intersect(peye,vcrrPtv);
		
		double pdist=crrPtv.distance(p0v);
		int[] ds={2,4,3};
		for(int d:ds){
			for(Point3d ps:_ApproximationPointVW(p0v,p1v,p2v,pdist,d)){
				if(ps.distance(crrPtv)<pdist/20){
					return ps;
				}
			}
		}
		shpLinesAx.setGeometry(null);
		return pv;
	}
	private class lineDistanceComp implements Comparator<Line>{
		private Point3d pt=null;
		public lineDistanceComp(Point3d p){
			this.pt=p;
		}
		public int compare(Line o1, Line o2) {
			double d=(o1.distance(pt)-o2.distance(pt));
			if(d==0)return 0;
			if(d<0) return -1;
			return 1;
		}
	}
	private List<Point3d> _ApproximationPointVW(Point3d pstart,Point3d pA,Point3d pB,double distance,int d){
		Vector3d vA=new Vector3d();
		Vector3d vB=new Vector3d();
		vA.sub(pA,pstart);
		vB.sub(pB,pstart);
		
		double arg=vA.angle(vB);
		//1xȉ̏ꍇ180x
		if(arg < 1/180d*Math.PI){
			arg+=Math.PI;
		}

		Vector3d axis=new Vector3d();
		axis.cross(vA,vB);
		axis.normalize();
		
		List<Point3d> pl=new ArrayList<Point3d>();
		
		shpLinesAx.setGeometry(null);
		LineArray g=new LineArray((d+1)*2,LineArray.COORDINATES);

		for(int i=0;i<d-1;i++){
			Vector3d pvec=new Vector3d(vA);
			pvec.scale(distance/pvec.length());

			Matrix4d matrix=new Matrix4d();
			matrix.set(new AxisAngle4d(axis,arg/d*(i+1)));
			matrix.transform(pvec);

			pvec.add(pstart);

			Point3d pt=new Point3d(pvec);
			pl.add(pt);
			g.setCoordinate(i*2+0,pstart);
			g.setCoordinate(i*2+1,pt);
		}
		g.setCoordinate((d-1)*2+0,pstart);
		g.setCoordinate((d-1)*2+1,pA);
		g.setCoordinate((d-0)*2+0,pstart);
		g.setCoordinate((d-0)*2+1,pB);
		shpLinesAx.setGeometry(g);

		return pl;
	}
	
	
	

}
