package jp.ac.nagoya_cu.sda.paper.interpolator;

import java.util.Enumeration;

import javax.media.j3d.Alpha;
import javax.media.j3d.RotationInterpolator;
import javax.media.j3d.Transform3D;
import javax.media.j3d.TransformGroup;
import javax.media.j3d.TransformInterpolator;
import javax.vecmath.AxisAngle4d;
import javax.vecmath.Matrix4d;

public class RotationViewInterpolator extends TransformInterpolator{
	protected Transform3D startT3d=new Transform3D();
	private float maxarg=0;
	private float minarg=0;


	public RotationViewInterpolator(){
		super();
	}
	
	public void processStimulus(Enumeration criteria){
		if(getAlpha()!=null && !getAlpha().finished()){
			float alpha=this.getAlpha().value();
	
			TransformGroup tg=getTarget();
			Transform3D t3d=new Transform3D();
			this.computeTransform(alpha,t3d);
			t3d.mul(startT3d);
			tg.setTransform(t3d);
		}
		
		wakeupOn(this.defaultWakeupCriterion);
	}
	
	public void computeTransform(float alpha,Transform3D t3d){
		float angle=(getMaximumAngle()-getMinimumAngle())*getAlpha().value()+getMinimumAngle();
		Transform3D t3dY=new Transform3D();
		t3dY.rotY(angle);
		
		t3d.mul(getTransformAxis(),t3dY);
		t3d.mulInverse(getTransformAxis());
	}
	
	public void setTransformAxis(Transform3D t3d){
		super.setTransformAxis(t3d);
		getTarget().getTransform(startT3d);
	}
	
	public float getMaximumAngle(){
		return maxarg;
	}
	public float getMinimumAngle(){
		return minarg;
	}
	public void setMaximumAngle(float angle){
		maxarg=angle;
	}
	public void setMinimumAngle(float angle){
		minarg=angle;
	}
	
	

}
