package jp.ac.nagoya_cu.sda.paper.shape;

import javax.media.j3d.*;
import javax.vecmath.*;
import jp.ac.nagoya_cu.sda.paper.Line;
import jp.ac.nagoya_cu.sda.paper.OriUtil;

public class LineShape extends OrigamiShape{
	protected Line ln = null;
	protected Shape3D lshape = null;
	
	protected double offset = 0.1;
	private Point3d pa=new Point3d();
	private Point3d pb=new Point3d();

	
	public LineShape(Line ln){
		ln.setLineShape(this);
		this.ln=ln;
		
		lshape = new Shape3D();
		lshape.setCapability(Shape3D.ALLOW_GEOMETRY_READ);
		lshape.setCapability(Shape3D.ALLOW_GEOMETRY_WRITE);
		lshape.setCapability(Shape3D.ALLOW_APPEARANCE_READ);
		lshape.setCapability(Shape3D.ALLOW_APPEARANCE_WRITE);
		setGeometry(this.ln);
		setAppearance(OriUtil.createLineAppearance(new Color3f(0,0,0),1,LineAttributes.PATTERN_SOLID));
		
		this.addChild(lshape);
	}
	
	public void setGeometry(Line ln){
		LineArray geometry = new LineArray(2,GeometryArray.COORDINATES);
		ln.getPointA().get(pa);
		ln.getPointB().get(pb);
//		pa.z+=offset;
//		pb.z+=offset;
		geometry.setCoordinate(0,pa);
		geometry.setCoordinate(1,pb);
		geometry.setCapability(GeometryArray.ALLOW_INTERSECT);
		geometry.setCapability(GeometryArray.ALLOW_COORDINATE_READ);
		geometry.setCapability(GeometryArray.ALLOW_COUNT_READ);
		geometry.setCapability(GeometryArray.ALLOW_FORMAT_READ);
		lshape.setGeometry(geometry);
	}
	
	public void setAppearance(Appearance ap){
		lshape.setAppearance(ap);
	}
	public Appearance getAppearance(){
		return lshape.getAppearance();
	}
	
	// |S𒸓_ɍ킹
	public void update() {
		setGeometry(ln);
	}
	public static Appearance createAppearance(Color3f color,float width) {
		Appearance ap = new Appearance();

		ColoringAttributes ca = new ColoringAttributes();
		ca.setShadeModel(ColoringAttributes.FASTEST);
		ca.setColor(color);
		ap.setColoringAttributes(ca);
		
		PolygonAttributes pa = new PolygonAttributes();
		pa.setPolygonMode(PolygonAttributes.POLYGON_LINE);
//		pa.setCullFace(PolygonAttributes.CULL_NONE);
		pa.setPolygonOffset(1f);
		pa.setPolygonOffsetFactor(1f);
		ap.setPolygonAttributes(pa);

		
		LineAttributes lattr = new LineAttributes();
		lattr.setLineWidth(width);
//		lattr.setLinePattern(LineAttributes.PATTERN_DASH);
		lattr.setLineAntialiasingEnable(true);
		ap.setLineAttributes(lattr);
		return ap;
	}
	
	public Line getLine(){
		return this.ln;
	}

}
